function H = HRiflettore(x)
% Riflettore elementare di Householder

n = length(x);

segno = sign(x(1));
if segno == 0
    segno = 1;
end
alpha = segno*norm(x);
e1 = eye(length(x),1);
v = x+alpha*e1;
u = v/norm(v);
H = eye(n)-2*u*u';
