x = [.5,.25]'
u = [1,0]'
uort = [0,1]'
P = HRiflettoreU(u)
y = P*x

figure(1);
h = quiver([0,0,0,0],[0,0,0,0],[x(1),y(1),u(1),uort(1)],[x(2),y(2),u(2),uort(2)],1);
set(h,'Color','k','LineWidth',2);
hold on
h = quiver([y(1)],[y(2)],[x(1)-y(1)],[x(2)-y(2)],1);
set(h,'Color','b','LineWidth',2,'LineStyle','--');
hold off

h = text(x(1)+0.05,x(2)+0.05,'x'); set(h,'FontSize',14);
h = text(y(1)+0.05,y(2)+0.05,'y'); set(h,'FontSize',14);
h = text(u(1)+0.05,u(2)+0.05,'u'); set(h,'FontSize',14);
h = text(uort(1)+0.05,uort(2)+0.05,'\Pi u'); set(h,'FontSize',14);
%h = line([0,x(1)],[x(2),x(2)]); set(h,'LineWidth',2,'LineStyle','--','Color','b');
h = text(0.05,x(2)+0.05,'2(u''x)u'); set(h,'FontSize',14);
% xlabel('e_1');
% ylabel('e_2');
axis([-0.7 1.2 -0.2 1.2]);
%axis off
%axis equal



% Esercizio 1
A = [3 -2 3; 12 0 1; -4 5 2]
P = HRiflettore(A(:,1));
 
A1 = P*A

% Esercizio 2
A = [3 -2 3; 12 0 1; -4 5 2]
[Q,R] = QR_withH(A)
[Qm,Rm] = qr(A)
A - Q*R

A = reshape(1:30,6,5)

[Q,R] = QR_withH(A)
[Qm,Rm] = qr(A)
A - Q*R

A = reshape(1:30,6,5)';
[Q,R] = QR_withH(A)
[Qm,Rm] = qr(A)
A - Q*R


% problema ai minimi quadrati
x = [-5 -3 1 3 4 6 8];
y = [18 7 0 7 16 50 67];

A = CostruisciA(x);

% Equazioni normali
[AtA, b] = SistNormale(x,y)
R = chol(AtA)
a = R\(R'\b)

res1 = norm(y(:)-A*a)

figure(2);
plot(x,y,'k*');
xval = linspace(-6,10);
yval = a(1)+a(2)*xval;
hold on
plot(xval,yval,'b--');
hold off

[Q,R] = QR_withH(A);
[Qm,Rm] = qr(A)
c = Q'*y(:)
c = c(1:2)
Rtilde = R(1:2,:)
asol = sost_indietro(Rtilde,c)
res2 = norm(y(:)-A*asol)


% Esempio con condizionamento elevato
bend = 1/2*pi*10;
x = linspace(0,bend,300);
y = sin(x);
%y = x+0.01*(rand(1,length(x))-0.5);
%y = x

A = CostruisciA(x);
% Equazioni normali
[AtA, b] = SistNormale(x,y)
cond(AtA)
R = chol(AtA)
a = R\(R'\b)

[Q,R] = QR_withH(A);
c = Q'*y(:);
c = c(1:2);
Rtilde = R(1:2,:);
asol = sost_indietro(Rtilde,c)

figure(3);
plot(x,y,'k*');
xval = linspace(0,bend,2);
yval1 = a(1)+a(2)*xval;
yval2 = asol(1)+asol(2)*xval;
hold on
plot(xval,yval1,'b--');
plot(xval,yval2,'r--');
hold off

a-asol
 