close all
clear all
clc

t = [0     15    30    45    60   75   90   105  120  150  180  210  240  300  360]';
y = [14.0  12.1  10.9  10.0  9.3  8.6  8.0  7.5  7.0  6.2  5.5  4.5  3.5  2.0  0.9]';

logy = log(y);
a = polyfit(t,logy,1);
N0 = exp(a(2));
lambda = -a(1)

tval = linspace(0,360)';
yval = N0.*exp(-lambda*tval);

figure;
h = plot(tval,yval,'k-');
set(h,'LineWidth',2);
hold on
h = plot(t,y,'r*');
set(h,'LineWidth',2);
hold off
legend('Dati modello','Dati sperim.');
