function [Q,R] = QR_withH(A)

[m,n] = size(A);

R = A;
Q = eye(m);

d = min([m-1,n]);

for k=1:d
    x = R(k:m,k);
    Pt = HRiflettore(x);
    P = eye(m);
    P(k:m,k:m) = Pt;
    R = P*R;
    Q = Q*P;
end
